#include "moveitem.h"
#include <qmath.h>

MoveItem::MoveItem(QObject *parent) :
    QObject(parent), QGraphicsItem(){
    pen.setColor(Qt::blue);
    pen.setWidth(2);
    pen.setCosmetic(true);
    X1=0;
    Y1=0;
    X2=100;
    Y2=100;
}

MoveItem::~MoveItem(){

}

QRectF MoveItem::boundingRect() const{
    return QRectF (X1,Y1,X2,Y2);
}

void MoveItem::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget){

    painter->setPen(pen);
    painter->drawRect(X1,Y1,X2,Y2);
    emit posChanged(this->pos());
    Q_UNUSED(option);
    Q_UNUSED(widget);
}

void MoveItem::mouseMoveEvent(QGraphicsSceneMouseEvent *event){
    /* Устанавливаем позицию графического элемента
     * в графической сцене, транслировав координаты
     * курсора внутри графического элемента
     * в координатную систему графической сцены
     * */
    this->setPos(mapToScene(event->pos() + m_shiftMouseCoords));
}

void MoveItem::mousePressEvent(QGraphicsSceneMouseEvent *event){
    /* При нажатии мышью на графический элемент
     * заменяем курсор на руку, которая держит этот элемента
     * */
    m_shiftMouseCoords = this->pos() - mapToScene(event->pos());
    this->setCursor(QCursor(Qt::ClosedHandCursor));
    Q_UNUSED(event);
}

void MoveItem::mouseReleaseEvent(QGraphicsSceneMouseEvent *event){
    /* При отпускании мышью элемента
     * заменяем на обычный курсор стрелку
     * */
    QPointF point = this->pos();
    qDebug() << "Coord " << QString::number(point.x()) << ":" << QString::number(point.y());
    this->setCursor(QCursor(Qt::ArrowCursor));
    Q_UNUSED(event);
}

void MoveItem::setSize(int a, int b){
    prepareGeometryChange();
    X2 = a;
    Y2 = b;
}

void MoveItem::changeSize(){
    prepareGeometryChange();
    X2 += 10;
    Y2 += 10;
}
